/* 

	Bu program Alper KANAT tarafndan Linux iletim sistemi iin kodlanmtr. 
Genel amac, antalara ayrlm DivX vb filmleri kategorilendirerek bulunmala-
rn kolaylatrmaktr.

*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct DivX {
	
	char isim[40];
	int cdno;
	char altyazi[20];
	int canta;
	float yaprak;
	char alim[20];
	struct DivX *nextPtr;
	
} divx;

typedef divx *divxPtr;

// Fonksiyon Deklarasyonu Balangc

void menu (); // Karlama Mens
void ekleme ( divxPtr *, char *, int, char *, int, float, char * ); // Listeye film ekler
void listele ( divxPtr ); // Programa yklenmi film listesini gsterir
void listeal (); // Programn alnda dosyadan film listesini alp programa ykleyecek
void listeyaz ( divx ); // Her film ekleniinde listeye eklenen son filmi dosyaya yazacak

// Fonksiyon Deklarasyonu Bitii

// Global Deiken Deklarasyonu Balangc

int i, j;

// Global Deiken Deklarasyonu Bitii

void listeyaz ( divx filmler ) {
	
	FILE *dosya;
	
	dosya = fopen ( "divxlistesi.txt", "a+b" );
	
	fwrite ( &filmler, sizeof ( divx ), 1, dosya );
	
	fclose ( dosya );
	
}

void listeal () {
	
	divxPtr startPtr = NULL;
	
	divxPtr newPtr;
	divxPtr curPtr;
	divxPtr prvPtr;
	
	divx filmler;
	
	FILE *dosya;
	
	dosya = fopen ( "divxlistesi.txt", "rb" );
	
	newPtr = malloc ( sizeof ( divx ) );
	
	while ( !feof ( dosya ) ) {
		
		fread ( &filmler, sizeof ( divx ), 1, dosya );
		printf("%s %d %s %d %.1lf %s\n", filmler.isim, filmler.cdno, filmler.altyazi, filmler.canta, filmler.yaprak, filmler.alim);
		
	}
	
	fclose ( dosya );
	
}

void listele ( divxPtr sPtr ) {
	
	if ( sPtr != NULL ) {
		
		printf("%s %d %s %d %.1lf %s\n", sPtr->isim, sPtr->cdno, sPtr->altyazi, sPtr->canta, sPtr->yaprak, sPtr->alim);
		sPtr = sPtr->nextPtr;
		
	}
	
	else {
		
		system("clear");
		printf("Listenizde film yok. Ltfen ekledikten sonra tekrar deneyin.\n\n");
		
	}
	
}

void ekleme ( divxPtr *sPtr, char *s1, int cdnum, char *s2, int cantano, float yaprakno, char *s3 ) {
	
	divxPtr newPtr;
	divxPtr curPtr;
	divxPtr prvPtr;
	
	newPtr = malloc ( sizeof ( divx ) );
	
	if ( newPtr != NULL ) {
		
		strcpy ( newPtr->isim, s1 );
		newPtr->cdno = cdnum;
		strcpy ( newPtr->altyazi, s2 );
		newPtr->canta = cantano;
		newPtr->yaprak = yaprakno;
		strcpy ( newPtr->alim, s3 );
		newPtr->nextPtr = NULL;
		
		prvPtr = NULL;
		curPtr = *sPtr;
		
		while ( curPtr != NULL ) {
			
			prvPtr = curPtr;
			curPtr = curPtr->nextPtr;
			
		}
		
		if ( prvPtr == NULL ) {
			
			newPtr->nextPtr = *sPtr;
  	  		*sPtr = newPtr;
			
		}
		
		else {
			
  	  		prvPtr->nextPtr = newPtr;
  	  		newPtr->nextPtr = curPtr;
  	  		
 		}
		
	}
	
	else {
		
		system("clear");
		printf("Bilgiler Yazlamad. Bellek Yetersiz.\n\n");
		
	}
	
}

void menu () {
	
	int x, y, z, uzunluk;
	char choice;
	
	char menu_baslik[] = "DivX Film Listesi Program";
	char ekle[] = "Yeni Film Ekle";
	char duzenle[] = "Filmleri Dzenle";
	char arama[] = "Film Ara";
	char listele[] = "Filmleri Listele";
	char alim[] = "Film Alm";
	
	system("clear");
	
	for (i=0; i<21; i++) {
		
		if ( i % 2 != 0 ) {
			
			if ( i == 1 ) {
				
				uzunluk = 70 - strlen(menu_baslik);
				
				if ( uzunluk % 2 == 0 ) {
					
					x = uzunluk / 2;
					y = uzunluk / 2;
					
				}
				
				else {
					
					x = uzunluk/2 - 1;
					y = uzunluk/2 + 1;
					
				}
				
				printf("    |");				
				for (j=0; j<x-1; j++)
					printf("%c", ' ');
				printf("%s", menu_baslik);
				for (j=0; j<y-1; j++)
					printf("%c", ' ');
				printf("|\n");
				
			}
			
			else {
				
				if ( i == 7 ) {
					
					z = strlen(ekle);
					y = 68 - (x+z);
					
					printf("    |");
					for (j=0; j<x-1; j++)
						printf("%c", ' ');
					printf("1) %s", ekle);
					for (j=0; j<y-2; j++)
						printf("%c", ' ');
					printf("|\n");
					
				}
				
				if ( i == 9 ) {
					
					z = strlen(duzenle);
					y = 68 - (x+z);
					
					printf("    |");
					for (j=0; j<x-1; j++)
						printf("%c", ' ');
					printf("2) %s", duzenle);
					for (j=0; j<y-2; j++)
						printf("%c", ' ');
					printf("|\n");
					
				}
				
				if ( i == 11 ) {
					
					z = strlen(arama);
					y = 68 - (x+z);
					
					printf("    |");
					for (j=0; j<x-1; j++)
						printf("%c", ' ');
					printf("3) %s", arama);
					for (j=0; j<y-2; j++)
						printf("%c", ' ');
					printf("|\n");
					
				}
				
				if ( i == 13 ) {
					
					z = strlen(listele);
					y = 68 - (x+z);
					
					printf("    |");
					for (j=0; j<x-1; j++)
						printf("%c", ' ');
					printf("4) %s", listele);
					for (j=0; j<y-2; j++)
						printf("%c", ' ');
					printf("|\n");
					
				}
				
				if ( i == 15 ) {
					
					z = strlen(alim);
					y = 68 - (x+z);
					
					printf("    |");
					for (j=0; j<x-1; j++)
						printf("%c", ' ');
					printf("5) %s", alim);
					for (j=0; j<y-2; j++)
						printf("%c", ' ');
					printf("|\n");
					
				}
				
				if ( i == 17 ) {
					
					z = strlen("k");
					y = 68 - (x+z);
					
					printf("    |");
					for (j=0; j<x-1; j++)
						printf("%c", ' ');
					printf("6) %s", "k");
					for (j=0; j<y-2; j++)
						printf("%c", ' ');
					printf("|\n");
					
				}
				
				if ( i == 19 )
					printf("    |%68c|\n", ' ');
				
			}
			
		}
		
		else {
			
			printf("%4c", ' ');
			
			if ( i < 3 ) {
				
				for (j=0; j<70; j++)
					printf("-");
				
				printf("\n");
				
			}
			
			else {
				
				if ( i == 20 ) {
				
					for (j=0; j<70; j++)
						printf("-");
				
					printf("\n");
					
				}
				
				else
					printf("|%68c|\n", ' ');
				
			}
			
		}
		
	}
	
	printf("    Choice: ");
	scanf("%c", &choice);
	
	switch ( (int) choice - 48 ) {
	
		case 1: menu();
		
		case 2: printf("    2. SEENEK..!\n"); break;
		
		case 3: printf("    3. SEENEK..!\n"); break;
		
		case 4: printf("    4. SEENEK..!\n"); break;
		
		case 5: printf("    5. SEENEK..!\n"); break;
		
		case 6: printf("    6. SEENEK..!\n"); break;
		
	
	}
	
}

main () {
	
	//divxPtr startPtr = NULL;
	//divx filmler;
	
	//strcpy ( filmler.isim, "Istanbul Kanatlarmn Altnda");
	//filmler.cdno = 2;
	//strcpy ( filmler.altyazi, "Var");
	//filmler.canta = 2;
	//filmler.yaprak = 4.2;
	//strcpy ( filmler.alim, "Mert LKER");
	
	
	//menu ();
	//ekleme ( &startPtr, "Istanbul Kanatlarmn Altnda", 2, "Var", 2, 4.2, "Mert LKER" );
	//ekleme ( &startPtr, filmler.isim, filmler.cdno, filmler.altyazi, filmler.canta, filmler.yaprak, filmler.alim );
	//listeyaz ( filmler );
	//listele ( startPtr );
	listeal ();
	
	return 0;
	
}

